# Overview - NVMe and VirtIO BLK SNAP

NVIDIA® Mellanox® BlueField SNAP and virtio-blk SNAP (Storage-defined Network Accelerated
Processing) technology enables hardware-accelerated virtualization of local storage. NVMe/virtioblk
SNAP presents networked storage as a local block-storage-device such as an SSD, emulating a
local drive on the PCIe bus. The host OS/hypervisor uses its standard storage driver, unaware that
communication is done, not with a physical drive, but with NVMe/virtio-blk SNAP framework. Any
logic may be applied to the I/O requests or to the data via the NVMe/virtio-blk SNAP framework
prior to redirecting the request and/or data over a fabric-based network to remote or local storage
targets.
NVMe/virtio-blk SNAP is based on NVIDIA® Mellanox® BlueField®-2 DPU family technology and
combines unique hardware-accelerated storage virtualization with the advanced networking and
programmability capabilities of the DPU. NVMe/virtio-blk SNAP together with the BlueField DPU
enable a world of applications addressing storage and networking efficiency and performance.

# Build

To build from the source:
    ./autogen.sh
    ./configure --with-snap=/usr/local/snap-latest --with-spdk=/opt/mellanox/spdk
    make 
    (Optional) make install

# Run
From systemd service:
    systemctrl start mlnx_snap -m <CPUMASK>

From sources:
    NVME_SNAP_LOGFILE_PATH=stdout samples/mlnx_snap_emu -m <CPUMASK>

# Tests

To run tests:
 - `tests/gtest_nvme_ctrl`
 - `tests/gtest_devx` (advanced)

Tests in the `gtest_nvme_ctrl` are to check NVME spec compliance and they can be run on any 
system.

Tests in `gtest_devx` is work in progress, at the moment failures are expected.

# Documentation

To generate documentation:
* Run `doxygen` at the top level project directory
* HTML documentation is generated under `html/`, point your browser to `index.html`

